package cc.smtweb.framework.core.mvc.service;

import cc.smtweb.framework.core.R;
import cc.smtweb.framework.core.SwMap;
import cc.smtweb.framework.core.annotation.SwBody;
import cc.smtweb.framework.core.annotation.SwService;
import cc.smtweb.framework.core.db.DbEngine;
import cc.smtweb.framework.core.db.EntityDao;
import cc.smtweb.framework.core.session.UserSession;

import java.util.HashMap;
import java.util.Map;

/**
 * Created by Akmm at 2022/3/2 10:39
 * 通用业务mvc总调度
 */
public abstract class AbstractCompService {
    public final static String TYPE_LIST = "list";
    public final static String TYPE_LOAD = "load";
    public final static String TYPE_SAVE = "save";
    public final static String TYPE_DEL = "del";

    protected abstract IHandler createHanlder(String type);

    private R pageHandler(SwMap params, UserSession us, String type) {
        try {
            IHandler handler = createHanlder(type);
            if (params == null) params = new SwMap();
            if (us == null) us = UserSession.createSys();
            return handler.doWork(params, us);
        } catch (Exception e) {
            return R.error("操作失败！", e);
        }
    }

    public R save(@SwBody SwMap params, UserSession us) {
        return pageHandler(params, us, TYPE_SAVE);
    }

    public R load(@SwBody SwMap params, UserSession us) {
        return pageHandler(params, us, TYPE_LOAD);
    }

    public R del(@SwBody SwMap params, UserSession us) {
        return pageHandler(params, us, TYPE_DEL);
    }

    public R list(@SwBody SwMap params, UserSession us) {
        return pageHandler(params, us, TYPE_LIST);
    }

    public R getTotal(@SwBody SwMap params, UserSession us) {
        try {
            AbstractListHandler handler = (AbstractListHandler)createHanlder(TYPE_LIST);
            return handler.getTotal(params, us);
        } catch (Exception e) {
            return R.error("操作失败！", e);
        }
    }
}
